import { GetConfigOverride } from '../types/Hook.types';
import { ResolveUrlConfigType } from '../types/HttpClients.types';
declare type HookReturnType<R> = {
    data: R;
    loading: boolean;
    total?: number;
    refetch: (c?: GetConfigOverride) => Promise<R>;
    meta?: {
        page: {
            'current-page': number;
            from: number;
            'per-page': number;
            to: number;
            total: number;
            'last-page': number;
        };
    };
};
/**
 * Hook to execute get Requests, if you want to execute it lazy passed the flag lazy to true
 * if lazy it will return an array, first position the getter function which will be a promise, the second
 * position it's the loading state
 * otherwise the hook will return an object, data position it's the response, and the loading position represents
 * the loading state, the request will be triggered on Mount
 * @author Alejandro <alejandro.devop@gmail.com>
 * @version 1.0.0
 * @param path
 * @param config
 * @param lazy
 */
declare const useGet: <R extends object>(path: string, config?: (import("../types/HttpClients.types").GetRequestConfigType & ResolveUrlConfigType & {
    onCompleted?: ((data?: any) => void) | undefined;
}) | undefined) => HookReturnType<R>;
export default useGet;
