var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { useEffect, useRef, useContext, useMemo, useCallback, useState } from 'react';
import { ApiContext } from '../components/ApiClient';
var usePreviousProps = function (value) {
    var valuesRef = useRef(value);
    useEffect(function () {
        valuesRef.current = value;
    });
    return valuesRef.current;
};
/**
 * Hook to execute get Requests, if you want to execute it lazy passed the flag lazy to true
 * if lazy it will return an array, first position the getter function which will be a promise, the second
 * position it's the loading state
 * otherwise the hook will return an object, data position it's the response, and the loading position represents
 * the loading state, the request will be triggered on Mount
 * @author Alejandro <alejandro.devop@gmail.com>
 * @version 1.0.0
 * @param path
 * @param config
 * @param lazy
 */
var useGet = function (path, config) {
    var _a = config || {}, onCompleted = _a.onCompleted, pageSize = _a.pageSize, currentPage = _a.currentPage, sorts = _a.sorts;
    var _b = useState(0), fetchesCount = _b[0], setFetchesCount = _b[1];
    var prevProps = usePreviousProps({
        sorts: sorts === null || sorts === void 0 ? void 0 : sorts.join(','),
        currentPage: currentPage,
        pageSize: pageSize
    });
    var _c = useState(false), loading = _c[0], setLoading = _c[1];
    // The loading flag and the response data are stored in the same state to avoid create multiple setStates and Multiple SetState calls
    var _d = useState(), _e = _d[0], data = _e === void 0 ? {} : _e, setData = _d[1];
    var _f = useContext(ApiContext), client = _f.client, dataProcessor = _f.dataProcessor;
    var _g = data, responseData = _g.data, responseMeta = __rest(_g, ["data"]);
    var sendRequest = useCallback(function (configOverride) { return __awaiter(void 0, void 0, void 0, function () {
        var response, requestRequest, otherResponseVars, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setFetchesCount(fetchesCount + 1);
                    if (!loading) {
                        setLoading(true);
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, client.doGet(path, __assign(__assign(__assign({}, config), configOverride), { sorts: sorts }))];
                case 2:
                    response = _a.sent();
                    if (dataProcessor && dataProcessor instanceof Function) {
                        response = dataProcessor(response);
                    }
                    requestRequest = response.data, otherResponseVars = __rest(response, ["data"]);
                    setLoading(false);
                    setData(__assign({ data: requestRequest, total: response.total || 0 }, otherResponseVars));
                    if (onCompleted) {
                        onCompleted(response);
                    }
                    return [2 /*return*/, response.data];
                case 3:
                    e_1 = _a.sent();
                    setLoading(false);
                    throw e_1;
                case 4: return [2 /*return*/];
            }
        });
    }); }, [config, path, setData, loading]);
    useEffect(function () {
        // If the currentPage or pageSize or sorts change, the request should be send again
        var shouldUpdate = (sorts === null || sorts === void 0 ? void 0 : sorts.join(',')) !== prevProps.sorts ||
            currentPage !== prevProps.currentPage ||
            pageSize !== prevProps.pageSize;
        // This makes sure the request it's send at least once.
        if ((!loading && !sorts) || fetchesCount === 0) {
            sendRequest();
        }
        else if (!loading && shouldUpdate) {
            sendRequest();
        }
    }, [pageSize, currentPage, sorts]);
    return useMemo(function () { return (__assign({ data: responseData, loading: loading, refetch: sendRequest }, responseMeta)); }, [loading, responseData, sendRequest]);
};
export default useGet;
//# sourceMappingURL=useGet.js.map